<?php
/*
Plugin Name: Zelig Show Plugins
Plugin URI: http://zeligplanet.altervista.org/2006/08/wordpress-plugin-zelig-show-plugins/
Description: Displays a list of all the active plugins of your web site.
Version: 1.2
Author: Corrado "Zelig"
Author URI: http://zeligplanet.altervista.org

--------------------------------------------------

Copyright (C) 2006 Corrado "Zelig" (email: zeligplanet AT altervista.org)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
The license is also available at http://www.gnu.org/copyleft/gpl.html
*/

function zelig_show_plugins($args = '') {
	parse_str($args, $r);
	if (!isset($r['show_count'])) $r['show_count'] = 1;
	if (!isset($r['before'])) $r['before'] = 'There are ';
	if (!isset($r['after'])) $r['after'] = ' active plugins in this blog!';
	if (!isset($r['description'])) $r['description'] = 0;

require_once(ABSPATH . 'wp-admin/admin-functions.php');

if ( get_settings('active_plugins') )
	$current_plugins = get_settings('active_plugins');

$plugins = get_plugins();


if (empty($plugins)) {
	echo '<p>';
	_e("Couldn't open plugins directory or there are no plugins available.");
	echo '</p>';
} else {
	?>
	<div class="plugins-list">
	<table width="100%" cellpadding="5" cellspacing="0">
	<?php
		$style = '';
		$zcp = 0;
	
		function sort_plugins($plug1, $plug2) {
			return strnatcasecmp($plug1['Name'], $plug2['Name']);
		}
		uksort($plugins, 'sort_plugins');
	
		foreach($plugins as $plugin_file => $plugin_data) {
			if (!empty($current_plugins) && in_array($plugin_file, $current_plugins)) {
				$zcp++;
				$plugin_data['Title'] = "{$plugin_data['Title']}";
				$style = ('class="alternate"' == $style|| 'class="alternate-plug-row"' == $style) ? '' : 'alternate';
				$style .= $style == 'alternate' ? '-plug-row' : 'plug-row';
				if ($style != '') $style = 'class="' . $style . '"';
				if ($r['description'] == 1) $descr = "{$plugin_data['Description']} ";
				echo "
				<tr $style>
					<td>{$plugin_data['Title']}</td>
					<td>{$plugin_data['Version']}</td>
					<td>".$descr.sprintf(__('By %s'), $plugin_data['Author'])."</td>
				</tr>";
			}
		}
	?>
	</table>
	</div>
	<?php
	if ($r['show_count']) {
		?><p><?php echo $r['before']; ?><strong><?php echo $zcp; ?></strong><?php echo $r['after'] ?></p><?php;
	}
}
}
?>